//
//  Bullet.cpp
//  GlobalGameJam17
//
//  Created by Cesar Parent on 22/01/2017.
//  Copyright © 2017 teamrocket. All rights reserved.
//

#include "Bullet.hpp"
#include "Utils.hpp"

Bullet::Bullet(float limit)
: GameObject("assets/sprites/part.png")
, speed_(Constants::ENEMY_SPEED * 2.5f)
, limit_(limit) {
    
    setXScale(3.f);
    setYScale(2.f);
    setColor(Constants::OVERLAY_COLOUR);
    setName(Constants::PLAYER_TAG);
}


void Bullet::update(double delta) {
    delta = (1.f/60.f) * InfRunner::instance().speedFactor();
    GameObject::update(delta);
    
    setX(position().x + speed_ * delta);
    if(position().x < 0.f || position().x > limit_) {
        removeFromParent();
    }
}

void Bullet::destroy() {
    auto expl = PlistDecoder::decodeObjectFromFile<EmitterNode>("assets/objects/explode.plist");
    expl->setPosition(position());
    expl->runAction(Action::sequence({
        Action::waitForDuration(.1f),
        Action::runBlock([=]{ expl->setEmit(false); }),
        Action::waitForDuration(1.f),
        Action::removeFromParent()
    }), "boom");
    parent()->addChild(expl);
    GameObject::destroy();
}

