//
//  Enemy.hpp
//  GlobalGameJam17
//
//  Created by Cesar Parent on 21/01/2017.
//  Copyright © 2017 teamrocket. All rights reserved.
//

#ifndef Enemy_hpp
#define Enemy_hpp

#include "GameObject.hpp"
#include "json.hpp"

using json = nlohmann::json;

class Enemy : public GameObject {
public:
    
    Enemy(const std::string& sprite, float baseLine = 0);
    
    virtual ~Enemy();
    
    void update(double delta) override;
    
    virtual void didEnterParent() override;
    
    virtual void willMoveFromParent() override;
    
    void goLeft() {
        direction_ = Direction::LEFT;
    }
    
    void goRight() {
        direction_ = Direction::RIGHT;
    }
    
    void stop() {
        direction_ = Direction::STOP;
    }
    
    virtual void destroy() override;
    
    virtual void didCollideWith(ARC<GameObject> other) override;
    
protected:
    
    enum Direction {
        LEFT    = -1,
        STOP    = 0,
        RIGHT   = 1
    };
    
    float       speed_;
    float       phase_;
    float       frequency_;
    float       amplitude_;
    float       baseLine_;
    Direction   direction_;
    
    ARC<EmitterNode> trail_;
    
    
};

#endif /* Enemy_hpp */
