//
//  GameObject.cpp
//  GlobalGameJam17
//
//  Created by Cesar Parent on 21/01/2017.
//  Copyright (c) 2017 teamrocket. All rights reserved.
//

#include <functional>
#include <fstream>
#include "json.hpp"
#include "GameObject.hpp"
#include "CollisionManager.hpp"

using json = nlohmann::json;
using namespace std;


GameObject::GameObject(const string& sprite)
: SpriteNode(sprite)
, categoryMask(0)
, collisionMask(0) {
}

GameObject::~GameObject() {
    // cleanup when the node is deleted.
}

void GameObject::willMoveFromParent() {
    CollisionManager::instance().removeObject(ARC<GameObject>{this});
}

void GameObject::destroy() {
    removeFromParent();
}
