//
//  GameObject.hpp
//  GlobalGameJam17
//
//  Created by Cesar Parent on 21/01/2017.
//  Copyright (c) 2017 teamrocket. All rights reserved.
//
#ifndef GameObject_hpp
#define GameObject_hpp

#include <Meteor/Meteor.h>
#include <iostream>
#include "InfRunner.hpp"
using namespace Meteor;

class GameObject : public SpriteNode {
public:
    
    // MARK: - Node Initialisation
    
    GameObject(const std::string& sprite);
    
    virtual ~GameObject();
    
    // MARK: - Game Logic
    
    virtual void willMoveFromParent() override;
    
    uint32_t    categoryMask;
    uint32_t    collisionMask;
    
    virtual Rect collider() {
        return frame();
    }
    
    virtual void didCollideWith(ARC<GameObject> other) {
        destroy();
    }
    
    virtual void destroy();
};

#endif /* GameObject_hpp */
