//
//  InfRunner.cpp
//  GlobalGameJam17
//
//  Created by Cesar Parent on 22/01/2017.
//  Copyright © 2017 teamrocket. All rights reserved.
//

#include <Meteor/Meteor.h>
#include "InfRunner.hpp"
#include "Utils.hpp"

InfRunner& InfRunner::instance() {
    static InfRunner instance_;
    return instance_;
}

InfRunner::InfRunner()
: needleFactor_(0.2f)
, gameOver_(false) {
    controls.left = false;
    controls.right = false;
}

float InfRunner::speedFactor() {
    return lerp(1.f, Constants::MAX_SPEED_MULT, needleFactor_);
}

float InfRunner::updateNeedle() {
    if(controls.left && !controls.right) {
        needleFactor_ -= Constants::NEEDLE_SPEED * (1.f/60.f);
    }
    if(controls.right && !controls.left) {
        needleFactor_ += Constants::NEEDLE_SPEED * (1.f/60.f);
    }
    needleFactor_ = clamp(needleFactor_, 0.f, 1.f);
    return needleFactor_;
}
