//
//  InfRunner.hpp
//  GlobalGameJam17
//
//  Created by Cesar Parent on 22/01/2017.
//  Copyright © 2017 teamrocket. All rights reserved.
//

#ifndef InfRunner_hpp
#define InfRunner_hpp

class InfRunner final {
public:
    
    static InfRunner& instance();
    
    void start() { gameOver_ = false; needleFactor_ = 0.2f; }
    void loose() { gameOver_ = true; }
    bool gameOver() { return gameOver_; }
    float needleFactor() { return needleFactor_; }
    float speedFactor();
    
    
    float updateNeedle();
    
    
    struct {
        bool left;
        bool right;
    } controls;
    
private:
    
    InfRunner();
    virtual ~InfRunner() {}
    
    InfRunner(const InfRunner&) = delete;
    InfRunner(InfRunner&&) = delete;
    InfRunner& operator=(const InfRunner&) = delete;
    
    float   needleFactor_;
    bool    gameOver_;
};

#endif /* InfRunner_hpp */
