//
//  MainMenu.cpp
//  GlobalGameJam17
//
//  Created by Cesar Parent on 22/01/2017.
//  Copyright (c) 2017 teamrocket. All rights reserved.
//
#include "MainMenu.hpp"
#include "TunerScene.hpp"

static float stackLevel(int level) {
    return level * 16.f;
}

void MainMenu::didMoveToView() {
    setZSort(true);
    
    auto back = alloc<SpriteNode>("assets/sprites/mainmenu.png");
    back->setZPosition(0);
    addChild(back);
    
    auto cont = PlistDecoder::decodeObjectFromFile<LabelNode>("assets/objects/label.plist");
    cont->setText("press any key to start");
    cont->setY(stackLevel(0));
    addChild(cont);
    
    Controls::setDelegate(this);
}

// MARK: - ControlDelegate

void MainMenu::keyDown(Meteor::Key aKey) {
    start();
}

void MainMenu::controllerButtonDown(int controller, Button aButton) {
    start();
}

void MainMenu::start() {
    Game::instance().presentScene(alloc<TunerScene>(),
                                  Transition::fadeWithDuration(.5f));
}
