//
//  Player.hpp
//  GlobalGameJam17
//
//  Created by Cesar Parent on 21/01/2017.
//  Copyright © 2017 teamrocket. All rights reserved.
//

#ifndef Player_hpp
#define Player_hpp

#include "GameObject.hpp"

class Player : public GameObject {
public:
    
    Player(float baseLine);
    
    virtual ~Player() {}
    
    virtual void update(double delta) override;
    
    virtual void didCollideWith(ARC<GameObject> other) override;
    
    virtual void destroy() override;
    
    virtual Rect collider() override {
        return frame().inset(2.f, 1.f);
    }
    
    bool canShoot();
    
    struct {
        bool jump;
        bool shoot;
    } controls;
    
private:
    
    void    doJump_(double delta);
    
    bool    grounded_;
    float   jumpControl_;
    float   acceleration_;
    float   vspeed_;
    float   baseLine_;
    float   nextShoot_;
    
};

#endif /* Player_hpp */
