//
//  ScoreManager.hpp
//  GlobalGameJam17
//
//  Created by Cesar Parent on 22/01/2017.
//  Copyright © 2017 teamrocket. All rights reserved.
//

#ifndef ScoreManager_hpp
#define ScoreManager_hpp

#include <vector>
#include <functional>

class ScoreManager final {
public:
    
    typedef std::function<void(int, int)> ScoreEnumerator;
    
    static ScoreManager& instance();
    
    void addScore(int score);
    
    void enumerateScores(ScoreEnumerator block, int limit = 5);
    
private:
    
    ScoreManager();
    virtual ~ScoreManager();
    ScoreManager(ScoreManager&&) = delete;
    ScoreManager(const ScoreManager&) = delete;
    ScoreManager& operator=(const ScoreManager&) = delete;
    
    std::vector<int> scores_;
    
};

#endif /* ScoreManager_hpp */
