//
//  SplashScreen.cpp
//  GlobalGameJam17
//
//  Created by Cesar Parent on 22/01/2017.
//  Copyright (c) 2017 teamrocket. All rights reserved.
//
#include "SplashScreen.hpp"
#include "MainMenu.hpp"

SplashScreen::~SplashScreen() {
    // cleanup when the scene is deleted
}

void SplashScreen::didMoveToView() {
    // called when the scene is entering the view
    setBackgroundColor({.05f, .05f, .05f});
    
    auto sprite = alloc<SpriteNode>("assets/sprites/pixelspark.png");
    sprite->setAnchorPoint(.5f, 0.f);
    sprite->setY(-size().width/6.f);
    addChild(sprite);
    
    auto text = PlistDecoder::decodeObjectFromFile<LabelNode>("assets/objects/label.plist");
    text->setText("pixelspark games");
    text->setFontColor(Color::whiteColor);
    text->setY(size().height/4.f);
    addChild(text);
    
    setAlpha(0.f);
    
    runAction(Action::sequence({
        Action::fadeAlphaTo(1.f, 2.f, Ease::outSine),
        Action::runBlock([] {
            Game::instance().presentScene(alloc<MainMenu>(),
                                          Transition::fadeWithDuration(2.f));
        })
    }), "splash");
}
