//
//  Tick.cpp
//  GlobalGameJam17
//
//  Created by Cesar Parent on 21/01/2017.
//  Copyright © 2017 teamrocket. All rights reserved.
//

#include "Tick.hpp"
#include "Utils.hpp"

Tick::Tick(float height)
: GameObject("assets/sprites/part.png")
, speed_(Constants::LEVEL_SPEED){
    setYScale(height);
    setAnchorPoint(1.f, 1.f);
}

void Tick::update(double delta) {
    delta = (1.f/60.f) * InfRunner::instance().speedFactor();
    
    GameObject::update(delta);
    setX(position().x - speed_ * delta);
    
    if(position().x < 0) {
        removeFromParent();
    }
}
