//
//  TunerScene.hpp
//  GlobalGameJam17
//
//  Created by Cesar Parent on 21/01/2017.
//  Copyright (c) 2017 teamrocket. All rights reserved.
//
#pragma once

#include <Meteor/Meteor.h>
#include <vector>
#include "Player.hpp"

using namespace Meteor;

class TunerScene : public Scene, public ControlsDelegate {
public:
    
    // MARK: - Game management and logic
    
    TunerScene();
    
    virtual ~TunerScene();
    
    void didMoveToView() override;
    
    void update(double delta) override;
    
    void togglePause();
    
    // MARK: - Control Delegate
    
    void keyDown(Key aKey) override;
    void keyUp(Key aKey) override;
    void controllerButtonDown(int controller, Button aButton) override;
    void controllerButtonUp(int controller, Button aButton) override;
    void controllerAxisMoved(int controller, Axis theAxis, float value) override;
    // MARK: - Notification Receivers
    
    void playerDied(Notification* notification);
    
    void explosion(Notification* notification);
    
    
private:
    
    // MARK: - Level Management
    
    void addEnemy();
    void addTick();
    void addBullet();
    void manageScore(double delta);
    
    int                     score_;
    float                   flexSeconds_;
    bool                    nextEnemy_;
    bool                    nextTick_;
    
    
    Rect                    bounds_;
    ARC<SpriteNode>         front_;
    ARC<Player>             player_;
    ARC<SpriteNode>         needle_;
    ARC<LabelNode>          pauseLabel_;
    ARC<LabelNode>          scoreLabel_;
    
};
