//
//  Constants.hpp
//  GlobalGameJam17
//
//  Created by Cesar Parent on 21/01/2017.
//  Copyright © 2017 teamrocket. All rights reserved.
//

#ifndef Constants_hpp
#define Constants_hpp

#include <string>
#include <cstdint>
#include <cstdlib>
#include <Meteor/Meteor.h>
using namespace Meteor;


namespace Constants {
    void reload();
    
    extern const std::string PLAYER_TAG;
    extern const std::string TICK_TAG;
    extern const std::string BULLET_TAG;
    extern const std::string ENEMY_TAG;
    
    extern const Color OVERLAY_COLOUR;
    
    extern float ENEMY_SPEED;
    extern float LEVEL_SPEED;
    extern float MAX_SPEED_MULT;
    
    extern float GRAVITY;
    extern float JUMP_IMPULSE;
    extern float JUMP_JETPACK;
    extern float JUMP_CONTROL;
    
    extern float SHOOT_INTERVAL;
    extern float NEEDLE_SPEED;
    extern int SCORE_PER_SECOND;
}

namespace Notif {
    extern const char* DEATH;
    extern const char* EXPLOSION;
}

namespace Utils {
    
    template <typename T>
    T random(T to) {
        return to * (static_cast<double>(std::rand()) / static_cast<double>(RAND_MAX));
    }
    
    template <typename T>
    T random(T from, T to) {
        if(from > to) std::swap(from, to);
        return from + random(to - from);
    }
    
}

#endif /* Constants_hpp */
