//
//  Geometry.h
//  Meteor
//
//  Created by Cesar Parent on 13/07/2015.
//  Copyright (c) 2015 Cesar Parent. All rights reserved.
//

#ifndef Meteor_Geometry_h
#define Meteor_Geometry_h

/*!
 * @defgroup    Geometry Geometry
 * @brief       The geometry module provides the tools to represent and modify geometric objects
 *              like vectors, polygons and affine transformations, as well as basic mathematics
 *              utility functions.
 */

#include "defines.h"
#include "Geometry/Utilities.h"
#include "Geometry/Vec.h"
#include "Geometry/Mat.h"
#include "Geometry/Rect.h"
#include "Geometry/Transform.h"
#include "Geometry/Polygon.h"

#endif
