//
//  Nodes.h
//  Meteor
//
//  Created by Cesar Parent on 16/07/2015.
//  Copyright (c) 2015 Cesar Parent. All rights reserved.
//

#ifndef Meteor_Nodes_h
#define Meteor_Nodes_h

/*!
 * @defgroup    GameObjects Game Objects
 * @brief       Game Objects are objects that can be drawn on screen by a Meteor game. They are
 *              subclasses of <code>Node</code>, and can be added to a Scene Graph.
 */

#include "defines.h"
#include "Nodes/Layer.h"
#include "Nodes/Node.h"
#include "Nodes/SpriteNode.h"
#include "Nodes/PolygonNode.h"
#include "Nodes/LabelNode.h"
#include "Nodes/Scene.h"
#include "Nodes/EmitterNode.h"
#include "Nodes/CameraNode.h"

#endif
